%global pypi_name decorator

Summary:        More easier to define signature-preserving function decorators and decorator factories.
Name:           python-%{pypi_name}
Version:        5.1.1
Release:        5%{?dist}

License:        BSD
URL:            https://github.com/micheles/decorator
Source0:        https://github.com/micheles/decorator/archive/refs/tags/decorator-%{version}.tar.gz

BuildArch:      noarch

BuildRequires:  python3-setuptools
BuildRequires:  python3-devel

%description
The aim of the decorator module it to simplify the usage of decorators for
the average programmer, and to popularize decorators by showing various 
non-trivial examples. Of course, as all techniques, decorators can be abused 
(I have seen that) and you should not try to solve every problem with a decorator, 
just because you can.
Technically speaking, any Python object which can be called with one argument can 
be used as a decorator. However, this definition is somewhat too large to be really 
useful. It is more convenient to split the generic class of decorators in two subclasses:
1.signature-preserving decorators, callable objects which accept a function as input and 
return a function as output, with the same signature
2.signature-changing decorators, i.e. decorators which change the signature of their 
input function, or decorators that return non-callable objects

%package -n python3-decorator
Summary:  More easier to define signature-preserving function decorators and decorator factories.
Provides: python3-decorator

%description -n python3-decorator
The aim of the decorator module it to simplify the usage of decorators for
the average programmer, and to popularize decorators by showing various 
non-trivial examples. Of course, as all techniques, decorators can be abused 
(I have seen that) and you should not try to solve every problem with a decorator, 
just because you can.
Technically speaking, any Python object which can be called with one argument can 
be used as a decorator. However, this definition is somewhat too large to be really 
useful. It is more convenient to split the generic class of decorators in two subclasses:
1.signature-preserving decorators, callable objects which accept a function as input and 
return a function as output, with the same signature
2.signature-changing decorators, i.e. decorators which change the signature of their 

%prep
%autosetup -p1 -n %{pypi_name}-%{version}

%build
%py3_build

%install
%py3_install

# Remove this when https://github.com/micheles/decorator/issues/32 is fixed.
find %{buildroot} -name SOURCES.txt~ -exec rm -f {} \;

%check
%{__python3} setup.py test

%files -n python3-%{pypi_name}
%doc README.rst CHANGES.md
%license LICENSE.txt
%{python3_sitelib}/decorator.py
%{python3_sitelib}/decorator-*.egg-info/
%{python3_sitelib}/__pycache__/*

%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-2
- Rebuilt for OpenCloudOS Stream 23

* Sun May 29 2022 blancheqli <blancheqli@tencent.com> - 5.1.1-1
- Initial build.
